#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<cstring>
#include<set>
#include<iterator>

#define SIZE 50
#define BIG 1000000
using namespace std;

struct heap {
	set<long long> s;
	long long data[BIG];
	int count;
	heap() {
		count = 0;
	}
	bool isempty() {
		return count==0;
	}
	void add(long long a) {
		//printf("added: %lld\n", a);
		if(s.find(a) != s.end())
			return;
		s.insert(a);
		data[count++] = a;
		bubbleup(count);
		
	}
	void bubbleup(int pos) {
		
		int npos = pos/2;
		if(npos <= 0)
			return;
		if(data[npos-1] > data[pos-1]) {
			long long tmp = data[npos-1];
			data[npos-1] = data[pos-1];
			data[pos-1] = tmp;
			bubbleup(npos);
		}
			
	}
	void bubbledown(int pos) {
		int npos = pos*2;
		if(npos <= count) {
			long long tmp = data[npos-1];
			if(npos+1 <= count)
				if(data[npos] < tmp) {
					tmp = data[npos];
					npos++;
				}
			if(data[pos-1] > tmp) {
				data[npos-1] = data[pos-1];
				data[pos-1] = tmp;
				bubbledown(npos);
			}
			
		}
	}
	long long remove() {		
		long long res = data[0];
		s.erase(res);
		data[0] = data[count-1];
		count--;
		bubbledown(1);
		return res;
	}
};

char str[SIZE];
int N;
long long X, Y;
long long p[SIZE];

/*
void fce(int pos, int num) {
	if(num > Y)
		return;
	if(num >= X)
		s.insert(num);
	for(int i=pos; i<N; i++) {
		int tmp  = num*p[i];
		fce(i,tmp);
	}
}
*/

int compare(const void* a, const void *b) {
	return *(int*)a - *(int*)b;
}



int main() {
	while(true) {
		heap h;
		//s.clear();
		scanf("%d", &N);
		if(N == 0)
			return 0;
		for(int i=0; i<N; i++)
			scanf("%lld", p+i);
		scanf("%lld %lld", &X, &Y);
		qsort(p, N, sizeof(long long), compare);
		h.add(1);
		int printed = 0;
		long long last = 0;
		while(!h.isempty()) {
			long long curr = h.remove();
			if(curr >= X && curr <= Y) {
				if(last != curr) {
				if(printed++)
					printf(",%lld", curr);
				else
					printf("%lld", curr);		
				} 
				last = curr;
			}
			if(curr <= Y) {
				for(int i=0; i<N; i++) {
					long long tmp = p[i]*curr;
					if(tmp <= Y)
						h.add(tmp);	
					else
						break;
				}
			}			
		}
		if(!printed){
			printf("none\n");
			continue;
		} else {
			printf("\n");
		}
		
	}
	return 0;
}